-- GeNeRaTeD fOr: cbs/Funcons/mini.cbs
{-# LANGUAGE OverloadedStrings #-}

module Funcons.Mini.Mini where

import Funcons.EDSL

import Funcons.Operations hiding (Values,libFromList)
entities = []

types = typeEnvFromList
    []

funcons = libFromList
    [("mini-show",StrictFuncon stepMini_show)]

mini_show_ fargs = FApp "mini-show" (fargs)
stepMini_show fargs =
    evalRules [rewrite1,rewrite2,rewrite3,rewrite4,rewrite5] []
    where rewrite1 = do
            let env = emptyEnv
            env <- vsMatch fargs [PADT "true" []] env
            rewriteTermTo (TFuncon (FValue (ADTVal "list" [FValue (Char 't'),FValue (Char 'r'),FValue (Char 'u'),FValue (Char 'e')]))) env
          rewrite2 = do
            let env = emptyEnv
            env <- vsMatch fargs [PADT "false" []] env
            rewriteTermTo (TFuncon (FValue (ADTVal "list" [FValue (Char 'f'),FValue (Char 'a'),FValue (Char 'l'),FValue (Char 's'),FValue (Char 'e')]))) env
          rewrite3 = do
            let env = emptyEnv
            env <- vsMatch fargs [VPAnnotated (VPMetaVar "I") (TName "integers")] env
            rewriteTermTo (TApp "to-string" [TVar "I"]) env
          rewrite4 = do
            let env = emptyEnv
            env <- vsMatch fargs [VPAnnotated (VPMetaVar "S") (TName "strings")] env
            rewriteTermTo (TVar "S") env
          rewrite5 = do
            let env = emptyEnv
            env <- vsMatch fargs [PADT "vector" [VPSeqVar "V*" StarOp]] env
            rewriteTermTo (TApp "string-append" [TFuncon (FValue (ADTVal "list" [FValue (Char '[')])),TApp "intersperse" [TFuncon (FValue (ADTVal "list" [FValue (Char ','),FValue (Char ' ')])),TApp "interleave-map" [TApp "mini-show" [TApp "assigned" [TName "given"]],TVar "V*"]],TFuncon (FValue (ADTVal "list" [FValue (Char ']')]))]) env